﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PetkaWebDav.Server.Framework.Enums
{
    #region Enumerators
    /// <summary>
    /// WebDav Common Response Codes
    /// </summary>
    public enum ServerResponseCode : int
    {
        /// <summary>
        /// 0: None
        /// </summary>
        /// <remarks>
        ///		Default enumerator value
        /// </remarks>
        None = 0,

        /// <summary>
        ///	200: Ok 
        /// </summary>
        Ok = 200,

        /// <summary>
        /// 207: Multi Status
        /// </summary>
        /// <remarks>Used by PropFind</remarks>
        MultiStatus = 207,

        /// <summary>
        /// 400: Bad Request
        /// </summary>
        BadRequest = 400,

        /// <summary>
        /// 401: Unauthorized
        /// </summary>
        Unauthorized = 401,

        /// <summary>
        /// 404: Not Found
        /// </summary>
        NotFound = 404,

        /// <summary>
        /// 403: Forbidden
        /// </summary>
        Forbidden = 403,

        /// <summary>
        /// 412: Precondition Failed
        /// </summary>
        /// <remarks></remarks>
        PreconditionFailed = 412,

        /// <summary>
        /// 501: Method Not Implemented
        /// </summary>
        MethodNotImplemented = 501
    }
    #endregion
}
