﻿using PetkaWebDav.Server.Framework.BaseClasses;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PetkaWebDav.Server.Framework.Interfaces
{
    /// <summary>
    /// Summary description for IDavRequestProcessError.
    /// </summary>
    internal interface IDavRequestProcessError
    {
        /// <summary>
        /// Clear the process errors
        /// </summary>
        void ClearProcessErrors();

        /// <summary>
        /// Add a new process error
        /// </summary>
        /// <param name="resource"></param>
        /// <param name="errorCode"></param>
        void AddProcessErrorResource(DavResourceBase resource, System.Enum errorCode);

        /// <summary>
        /// Retrieve the current process errors
        /// </summary>
        Enum[] ProcessErrorResources
        {
            get;
        }
    }
}
