﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PetkaWebDav.Server.Framework.Security
{
    /// <summary>
    /// Authentication event arguments
    /// </summary>
    public sealed class AuthorizationArgs : EventArgs
    {
        /// <summary>
        /// Authorization event arguments
        /// </summary>
        /// <param name="authArgs"></param>
        public AuthorizationArgs(AuthenticationArgs authArgs)
        {
            this.AuthenticationInfo = authArgs;
        }

        /// <summary>
        /// Authentication Info
        /// </summary>
        public AuthenticationArgs AuthenticationInfo { get; private set; }

        /// <summary>
        /// UserName
        /// </summary>
        public string UserName { get; internal set; }

        /// <summary>
        /// Request Authorization
        /// </summary>
        public bool RequestAuthorized { get; internal set; }
    }
}
